//
//  Playfield.h
//  Demine
//
//  Created by Michael Heyeck on 4/9/10.
//  Copyright Fair Oaks Labs, Inc. 2010. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "TapDetectingView.h"
#import "Puzzle.h"


@interface Playfield : UIViewController <UIScrollViewDelegate, TapDetectingViewDelegate>
{
	NSArray*			box;			// Paths making up the box
	NSArray*			glyphs;			// Pre-calculated arrays of glyphs for tiles
	NSArray*			contents;		// Pre-calculated images for tiles
	Puzzle*				puzzle;			// The minesweeper puzzle to be rendered
	
	CGSize				world;			// Overall size of the world, in "world units"
	CGFloat				scale;			// Scales world units to pixels
	NSMutableArray*		tiles;			// The set of all tiles ever created
	NSMutableSet*		extraTiles;		// The set of currently unused tiles
	CGRect				tileBox;		// The box of currently displayed tiles, in tile indices
	
	UIView*				content;		// A wrapper view around the tiles; used for zooming
}

@property (nonatomic, retain) IBOutlet UIView* content;

- (id)initWithNibName:(NSString*)nibNameOrNil bundle:(NSBundle*)nibBundleOrNil puzzle:(Puzzle*)puzzle;

@end

