//
//  Puzzle.h
//  Demine
//
//  Created by Michael Heyeck on 4/9/10.
//  Copyright 2010 Fair Oaks Labs, Inc.. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface Puzzle : NSObject
{
	NSUInteger		w;
	NSUInteger		h;
	NSUInteger		m;
	
	char*			cells;
}

@property (nonatomic, assign, readonly) NSUInteger w;
@property (nonatomic, assign, readonly) NSUInteger h;
@property (nonatomic, assign, readonly) NSUInteger m;

- (id)initWithWidth:(NSUInteger)w height:(NSUInteger)h mines:(NSUInteger)m;

- (void)generate;
- (void)revealCell:(CGPoint)pos;

- (BOOL)isLegalCell:(CGPoint)pos;
- (BOOL)isRevealedCell:(CGPoint)pos;
- (BOOL)isMinedCell:(CGPoint)pos;
- (NSUInteger)neighborsOfCell:(CGPoint)pos;

@end
